// Person.c++

#include <iostream.h>
#include <Person.h++>

Person::Person(char *target)
{
  bzero(&opts,sizeof(pfopts));
  host = new char[strlen(target)+1];
  strcpy(host,target);

  if (!( client = clnt_create( host, PFINDERPROG, PFINDERVERS2, "tcp")))
    clnt_pcreateerror( host ), exit(1);

  opts.kalman = YES;
  opts.alive_coords = YES;
  opts.f3 = YES;
  opts.cc3d = YES;
  opts.g = 1;
  // opts.texture = YES;


  screen = pfscrsize_2( NULL, client );
  if (!screen) clnt_perror(client, host), exit(-1);
  
  range[0] = screen->x;
  range[1] = screen->y;
}

Person::~Person()
{
  delete [] host; 
}

void
Person::update( )
{
  person = pf_2(&opts, client);
    if (!person) clnt_perror(client, host), exit(-1);
    
    if (person->g.opt)
       {
	   pfgest_s *bits = person->g.pfgest_u.bits;
	   
	   User_exists = bits -> user_exists;
	   Extend_left = bits -> extend_right;
	   Extend_right = bits -> extend_left;
	   Point_left = bits -> point_right;
	   Point_right = bits -> point_left;
	   Hand_moving_left = bits -> hand_moving_right;
	   Hand_moving_right = bits -> hand_moving_left;
	   Kick_left = bits -> kick_right;
	   Kick_right = bits -> kick_left;
	   Throw_left = bits -> throw_right;
	   Throw_right = bits -> throw_left;
	   Standing = bits -> standing;
	   Sitting = bits -> sitting;
	   Bending_over = bits -> bending_over;
       }	 
    
    if (person->f3.opt) 
       {
	   pfinfof3_e *feats = person->f3.pfinfof3_u.feats->parts.parts_val;
	   
	   global[0] = feats[pfrpc_CENTROID].pos.x; 
	   global[1] = feats[pfrpc_CENTROID].pos.y;
	   global[2] = feats[pfrpc_CENTROID].pos.z;
	   left[0] = feats[pfrpc_RIGHTHAND].pos.x;
	   left[1] = feats[pfrpc_RIGHTHAND].pos.y;
	   left[2] = feats[pfrpc_RIGHTHAND].pos.z;
	   right[0] = feats[pfrpc_LEFTHAND].pos.x;
	   right[1] = feats[pfrpc_LEFTHAND].pos.y;
	   right[2] = feats[pfrpc_LEFTHAND].pos.z;
	   head[0] = feats[pfrpc_HEAD].pos.x;
	   head[1] = feats[pfrpc_HEAD].pos.y;
	   head[2] = feats[pfrpc_HEAD].pos.z;
	   
	   leftvalid = feats[pfrpc_RIGHTHAND].valid;
	   rightvalid =feats[pfrpc_LEFTHAND].valid;

	   LhandOverHead = (left[1] > head[1]) ? TRUE : FALSE;
	   RhandOverHead = (right[1] > head[1]) ? TRUE : FALSE;
       }
    
    if (person->cc3d.opt) 
      {
	 pfinfocc3_s *cc = person->cc3d.pfinfocc3_u.parts.parts_val;

	 if(person->cc3d.pfinfocc3_u.parts.parts_len > 7) 
	   {
	     right[0]= cc[pfLEFTHAND].pos.x;
	     right[1]= cc[pfLEFTHAND].pos.y;
	     right[2]= cc[pfLEFTHAND].pos.z;
	     left[0]= cc[pfRIGHTHAND].pos.x;
	     left[1]= cc[pfRIGHTHAND].pos.y;
	     left[2]= cc[pfRIGHTHAND].pos.z;
	     global[0]= cc[pfGLOBAL].pos.x;
	     global[1]= cc[pfGLOBAL].pos.y;
	     global[2]= cc[pfGLOBAL].pos.z;
	     waist[0]= cc[pfTHIGHS].pos.x;
	     waist[1]= cc[pfTHIGHS].pos.y;
	     waist[2]= cc[pfTHIGHS].pos.z;
	     chest[0]= cc[pfCHEST].pos.x;
	     chest[1]= cc[pfCHEST].pos.y;
	     chest[2]= cc[pfCHEST].pos.z;
	     head[0]= cc[pfHEAD].pos.x;
	     head[1]= cc[pfHEAD].pos.y;
	     head[2]= cc[pfHEAD].pos.z;
	     rfoot[0]= cc[pfLEFTFOOT].pos.x;
	     rfoot[1]= cc[pfLEFTFOOT].pos.y;
	     rfoot[2]= cc[pfLEFTFOOT].pos.z;
	     lfoot[0]= cc[pfRIGHTFOOT].pos.x;
	     lfoot[1]= cc[pfRIGHTFOOT].pos.y;
	     lfoot[2]= cc[pfRIGHTFOOT].pos.z;

	     right_color[0]= cc[pfLEFTHAND].cmean.x;
	     right_color[1]= cc[pfLEFTHAND].cmean.y;
	     right_color[2]= cc[pfLEFTHAND].cmean.z;
	     left_color[0]= cc[pfRIGHTHAND].cmean.x;
	     left_color[1]= cc[pfRIGHTHAND].cmean.y;
	     left_color[2]= cc[pfRIGHTHAND].cmean.z;
	     global_color[0]= cc[pfGLOBAL].cmean.x;
	     global_color[1]= cc[pfGLOBAL].cmean.y;
	     global_color[2]= cc[pfGLOBAL].cmean.z;
	     waist_color[0]= cc[pfTHIGHS].cmean.x;
	     waist_color[1]= cc[pfTHIGHS].cmean.y;
	     waist_color[2]= cc[pfTHIGHS].cmean.z;
	     chest_color[0]= cc[pfCHEST].cmean.x;
	     chest_color[1]= cc[pfCHEST].cmean.y;
	     chest_color[2]= cc[pfCHEST].cmean.z;
	     head_color[0]= cc[pfHEAD].cmean.x;
	     head_color[1]= cc[pfHEAD].cmean.y;
	     head_color[2]= cc[pfHEAD].cmean.z;
	     rfoot_color[0]= cc[pfLEFTFOOT].cmean.x;
	     rfoot_color[1]= cc[pfLEFTFOOT].cmean.y;
	     rfoot_color[2]= cc[pfLEFTFOOT].cmean.z;
	     lfoot_color[0]= cc[pfRIGHTFOOT].cmean.x;
	     lfoot_color[1]= cc[pfRIGHTFOOT].cmean.y;
	     lfoot_color[2]= cc[pfRIGHTFOOT].cmean.z;

	     right_scale[0]=  2.0 * cc[pfLEFTHAND].gL.x;
	     right_scale[1]=  2.0 * cc[pfLEFTHAND].gL.y;
	     right_scale[2]=  2.0 * cc[pfLEFTHAND].gL.z;
	     left_scale[0]=   2.0 * cc[pfRIGHTHAND].gL.x;
	     left_scale[1]=   2.0 * cc[pfRIGHTHAND].gL.y;
	     left_scale[2]=   2.0 * cc[pfRIGHTHAND].gL.z;
	     global_scale[0]= 2.0 * cc[pfGLOBAL].gL.x;
	     global_scale[1]= 2.0 * cc[pfGLOBAL].gL.y;
	     global_scale[2]= 2.0 * cc[pfGLOBAL].gL.z;
	     waist_scale[0]=  2.0 * cc[pfTHIGHS].gL.x;
	     waist_scale[1]=  2.0 * cc[pfTHIGHS].gL.y;
	     waist_scale[2]=  2.0 * cc[pfTHIGHS].gL.z;
	     chest_scale[0]=  2.0 * cc[pfCHEST].gL.x;
	     chest_scale[1]=  2.0 * cc[pfCHEST].gL.y;
	     chest_scale[2]=  2.0 * cc[pfCHEST].gL.z;
	     head_scale[0]=   2.0 * cc[pfHEAD].gL.x;
	     head_scale[1]=   2.0 * cc[pfHEAD].gL.y;
	     head_scale[2]=   2.0 * cc[pfHEAD].gL.z;
	     rfoot_scale[0]=  2.0 * cc[pfLEFTFOOT].gL.x;
	     rfoot_scale[1]=  2.0 * cc[pfLEFTFOOT].gL.y;
	     rfoot_scale[2]=  2.0 * cc[pfLEFTFOOT].gL.z;
	     lfoot_scale[0]=  2.0 * cc[pfRIGHTFOOT].gL.x;
	     lfoot_scale[1]=  2.0 * cc[pfRIGHTFOOT].gL.y;
	     lfoot_scale[2]=  2.0 * cc[pfRIGHTFOOT].gL.z;

		
	     right_angle= atan2(cc[pfLEFTHAND].gS[1].y,cc[pfLEFTHAND].gS[1].x);
	     left_angle= atan2(cc[pfRIGHTHAND].gS[1].y,cc[pfRIGHTHAND].gS[1].x);
	     global_angle= atan2(cc[pfGLOBAL].gS[1].y,cc[pfGLOBAL].gS[1].x);
	     waist_angle= atan2(cc[pfTHIGHS].gS[1].y,cc[pfTHIGHS].gS[1].x);
	     chest_angle= atan2(cc[pfCHEST].gS[1].y,cc[pfCHEST].gS[1].x);
	     head_angle= atan2(cc[pfHEAD].gS[1].y,cc[pfHEAD].gS[1].x);
	     rfoot_angle= atan2(cc[pfLEFTFOOT].gS[1].y,cc[pfLEFTFOOT].gS[1].x);
	     lfoot_angle= atan2(cc[pfRIGHTFOOT].gS[1].y,cc[pfRIGHTFOOT].gS[1].x);

	   }
      }
    

    else
       {

	   chest[0] = 0.0;
	   chest[1] = 0.0;
	   chest[2] = 0.0;
	   waist[0] = 0.0;
	   waist[1] = 0.0;
	   waist[2] = 0.0;
	   left[0] = 0;
	   left[1] = 0;
	   left[2] = 0;
	   right[0]= 0;
	   right[1]= 0;
	   right[2]= 0;
	   head[0] = 0;
	   head[1] = 0;
	   head[2] = 0;
	   rfoot[0]= 0.0;
	   rfoot[1]= 0.0;
	   rfoot[2]= 0.0;
	   lfoot[0]= 0.0;
	   lfoot[1]= 0.0;
	   lfoot[2]= 0.0;
       }
    if (!clnt_freeres(client, (xdrproc_t)xdr_pfperson, person))
      {
	cerr << "failed to free resource!!" << endl;
      }
}

