// Person.h++

#ifndef _Person_H_
#define _Person_H_

#include <rpc/rpc.h>
#include <string.h>
#include <pfinder_clnt.h>
#include <Inventor/SbLinear.h>

typedef enum  { pfGLOBAL=pfrpc_CENTROID, pfRIGHTHAND=pfrpc_RIGHTHAND, pfLEFTHAND=pfrpc_LEFTHAND,
		pfHEAD=pfrpc_HEAD, pfRIGHTFOOT=pfrpc_RIGHTFOOT, pfLEFTFOOT=pfrpc_LEFTFOOT,
		pfCHEST=pfrpc_CHEST, pfTHIGHS=pfrpc_THIGHS, pfWAIST=pfrpc_WAIST } pfClassDesig;
		
class Person
{
  CLIENT *client;
  pfinfo *person;
  pfopts opts;
  pfv2f *screen;
  char *host;
public:
  Person(char *);
  ~Person();
  void update( );

  SbVec3f range;

  SbVec3f global;
  SbVec3f chest;
  SbVec3f waist;
  SbVec3f left;
  SbVec3f right;
  SbVec3f head;
  SbVec3f lfoot;
  SbVec3f rfoot;
  SbVec3f global_color;
  SbVec3f chest_color;
  SbVec3f waist_color;
  SbVec3f left_color;
  SbVec3f right_color;
  SbVec3f head_color;
  SbVec3f lfoot_color;
  SbVec3f rfoot_color;
  SbVec3f global_scale;
  SbVec3f chest_scale;
  SbVec3f waist_scale;
  SbVec3f left_scale;
  SbVec3f right_scale;
  SbVec3f head_scale;
  SbVec3f lfoot_scale;
  SbVec3f rfoot_scale;
  float global_angle;
  float chest_angle;
  float waist_angle;
  float left_angle;
  float right_angle;
  float head_angle;
  float lfoot_angle;
  float rfoot_angle;
  
  SbBool User_exists;

  SbBool Extend_left;
  SbBool Extend_right;
  SbBool Point_left;
  SbBool Point_right;
  SbBool Hand_moving_left;
  SbBool Hand_moving_right;
  SbBool Kick_left;
  SbBool Kick_right;
  SbBool Throw_left;
  SbBool Throw_right;
  SbBool Standing;
  SbBool Sitting;
  SbBool Bending_over;
  SbBool LhandOverHead;
  SbBool RhandOverHead;

  SbBool leftvalid;
  SbBool rightvalid;

};

#endif // _HandMouse_H_
