// UserBody.c++

#include "UserBody.h++"

UserBodyObject::UserBodyObject()
  : ball( new SoSeparator ),
    shape( new SoSphere ),
    xform1( new SoTransform ),
    xform2( new SoTransform ),
    material( new SoMaterial ),
    textRoot( new SoSeparator ),
    text( new SoText3 ),
    textXform( new SoTransform ),
    textFont ( new SoFont )
{
    ball -> ref();
    ball -> addChild( material ); 
    ball -> addChild( xform1 ); 
    ball -> addChild( textRoot );
    ball -> addChild( xform2 ); 
    ball -> addChild( shape );

    textFont->name.setValue("Times-Roman");
    textFont->size.setValue(6.0);
// if you want mirrored text
    text -> parts = SoText3::BACK;
    textXform -> rotation.setValue( 0, 1, 0, 0 );
    textXform -> scaleFactor.setValue( -1, 1, 1 );

    textRoot -> addChild( textXform );
    textRoot -> addChild( textFont );
    textRoot -> addChild( text );

}

UserBody::UserBody()
: body( new SoSeparator )

{
    body -> ref();

  objects[ CHEST ].setColor( .93, .51, .93 );
  objects[ WAIST ].setColor( .93, .51, .93 );
  objects[ HEAD ].setColor( .68, .85, .90 );
  objects[ LHAND ].setColor( 1, 0, 0 );
  objects[ RHAND ].setColor( 0, 1, 0 );
  objects[ LFOOT ].setColor( 1, 1, 0 );
  objects[ RFOOT ].setColor( 0, 0, 1 );


  for( int i = 0; i < 7; i++ )
     body -> addChild( objects[i].getNode() );

}

UserBody::~UserBody()
{
  body -> unref();
}











